// Disk
// tULAMIDE
// PS 2.0
// Draws an ellipse with optional outline.

//#PARAM percent outline 0.1 : Outline : The thickness of the outline.
//#PARAM percent olsmooth 0.2 : Smooth Outline : How much of the outline's thickness is used for smoothing.
//#PARAM percent olopacity 1.0 : Outline Opacity: 0% = Transparent, 100% = Opaque
float outline;
float olsmooth;
float olopacity;

float boxLeft;
float boxTop;
float boxWidth;
float boxHeight;

// Foreground texture
texture ForegroundTexture;

// Foreground sampler
sampler2D foreground = sampler_state {
    Texture = (ForegroundTexture);
    MinFilter = Linear;
    MagFilter = Linear;
    MipFilter = Linear;
};

// Effect function
float4 EffectProcess( float2 Tex : TEXCOORD0 ) : COLOR0
{
    float2 coord = float2((Tex.x - boxLeft) / boxWidth - 0.5, (Tex.y - boxTop) / boxHeight - 0.5);
	coord *= 2;
	
    float dist = distance(coord, float2(0, 0));
	float oSM = outline * (olsmooth / 2);
	float oH = 1.0 - oSM;
	float oL = 1.0 - outline + oSM;
	
	float oSH = 1.0 - ((dist - oH) / oSM);
	float oSL = 1.0 - ((oL - dist) / oSM);
	oSH = oSH<0||oSH>1?0:oSH;
	oSL = oSL<0||oSL>1?0:oSL;
	
	float oOP = max(oSL, oSH);
	oOP = dist>oL&&dist<oH?1:oOP;
	
	float4 input = tex2D(foreground, Tex.xy);
	input.rgb /= input.a;
	
	float4 output = float4(input.rgb, oOP * olopacity);
	output.rgb *= output.a;
    return output;
}

// ConstructEffect
technique ConstructEffect
{
    pass p0
    {
        VertexShader = null;
        PixelShader = compile ps_2_0 EffectProcess();
    }
}